/*;  khslist.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.2 $$ {\rhead{\sl khslist.h\quad\thepage}} */
/*;  $$Date: 1997/09/03 03:22:00 $$  */
/*;  $$Source: /home/shiiba/KhC++LibDevelop/lists/khslist.h,v $$  */

/*
ΥץϡScott Robert Ladd ˤ C++ Templates and Tools
˷ǺܤƤץ򸵤ˤƤޤ

Υץϡ㳰(try, throw, catch ʤɤȤ)Υɤ
Ǥޤ̾Υ顼(顼å񤤤ơexit )
֤Ƥޤ

ޤ饹 SListDynamic ˥дؿ Remove ɲäޤRemove ϡ
 Work ؤƤܤꥹȤޤ

Υե khslist.h γˡե khslist.cc ޤʬ䥳
ѥ뤹ΤǤʤϡkhslist.h ˤĤŤ khslist.cc  include Ƥ

*/

//=============================================================
// Singly-Linked Lists      khslist.h         v1.00
//      Defines templates for classes of singly-linked lists
//      Copyright 1995 Scott Robert Ladd
//=============================================================

#ifndef MSSLIST_H
#define MSSLIST_H

#include <limits.h>
#include <assert.h>
#include <stddef.h>
#include "khsimple.h"
#include "khboolean.h"

//---------------------------
// dynamic singly-linked list
//---------------------------

template <class T>
class KhSListDynamic
{
 public:
  // constructors
  KhSListDynamic
  (
   KhBoolean circ = NO
   );

  // copy constructor
  KhSListDynamic
  (
   const KhSListDynamic<T> & slst,
   KhBoolean shallow = NO
   );

  // construct from array
  KhSListDynamic
  (
   const T * array,
   size_t no
   );

  // destructor
  ~KhSListDynamic();

  // assignment operator (deep copy)
  void operator =
  (
   const KhSListDynamic<T> & slst
   );

  // conversion to array operator
  operator T * ();

  // append new items
  void Append
  (
   const T & item
   );

  void Append
  (
   const T * array,
   size_t no
   );

  void Append
  (
   const KhSListDynamic<T> & slst
   );

  // remove current item
  // ιܤդɲäޤɤ⡤ܤɬפ
  // Τʤ顤DList<Type> Ȥ®Ǥ

  void Remove();

  // remove all items from the list
  void Erase();

  // get current item
  T Get();

  // YES if current item is last item
  KhBoolean AtTail();

  // set current item to head of list
  // Ȥϡͤλϡvoid Ǥդ KhBoolean 
  // ֤ͤ褦ѹޤꥹȤ1ĤǤ̵Ȥϡ
  // NO = 0 ֤ʤȤ1ǤȤϡ 0 ֤ޤ
  KhBoolean ToHead();

  // move to next item in list
  KhBoolean ToNext();

  // interrogate list
  size_t  GetCount();
  KhBoolean IsShallow();
  KhBoolean IsCircular();

 protected:
  // type defining a node in the list
  struct Node
  {
	T Data;
	Node * Next;
  };

  size_t Count; // # of items in list
  Node * Head;  // first item
  Node * Tail;  // last item
  Node * Work;  // current item

  KhBoolean Shallow;  // Is this a shallow copy?
  KhBoolean Circular; // is this a circular list?

  // internal utility functions
  void DeepCopy
  (
   const KhSListDynamic<T> & slst
   );

  void ShallowCopy
  (
   const KhSListDynamic<T> & slst
   );

  void SetNull();
};

// inline member functions

template <class T>
inline void KhSListDynamic<T>::ShallowCopy
(
 const KhSListDynamic<T> & slst
 )
{
  Head  = slst.Head;
  Tail  = slst.Tail;
  Work  = slst.Work;
  Count = slst.Count;
  Shallow  = YES;
  Circular = slst.Circular;
}

template <class T>
inline void KhSListDynamic<T>::SetNull()
{
  Head  = NULL;
  Tail  = NULL;
  Work  = NULL;
  Count = 0;
}

// constructors
template <class T>
inline KhSListDynamic<T>::KhSListDynamic
(
 KhBoolean circ
 )
{
  SetNull();
  Shallow  = NO;
  Circular = circ;
}

// destructor
template <class T>
inline KhSListDynamic<T>::~KhSListDynamic()
{
  Erase();
}

// YES if current item is last item
template <class T>
inline KhBoolean KhSListDynamic<T>::AtTail()
{
  if (Work == Tail)
	return YES;
  else
	return NO;
}

// set current item to head of list
template <class T>
inline KhBoolean KhSListDynamic<T>::ToHead()
{
  Work = Head;
  if (Count == 0)
  {
    return NO;
  }
  else
  {
    return YES;
  }
}

// interrogate list
template <class T>
inline size_t KhSListDynamic<T>::GetCount()
{
  return Count;
}

template <class T>
inline KhBoolean KhSListDynamic<T>::IsShallow()
{
  return Shallow;
}

template <class T>
inline KhBoolean KhSListDynamic<T>::IsCircular()
{
  return Circular;
}

//--------------------------
// static singly-linked list
//--------------------------

template <class T, size_t Limit>
class KhSList
{
 public:
  // constructors
  KhSList
  (
   KhBoolean circ = NO
   );

  // copy constructor
  KhSList
  (
   const KhSList<T,Limit> & slst
   );

  // construct from array
  KhSList
  (
   const T * array,
   size_t no
   );

  // destructor
  ~KhSList();

  // assignment operator (deep copy)
  void operator =
  (
   const KhSList<T,Limit> & slst
   );

  // conversion to array operator
  operator T * ();

  // append new items
  void Append
  (
   const T & item
   );

  void Append
  (
   const T * array,
   size_t no
   );

  void Append
  (
   const KhSList<T,Limit> & slst
   );

  // remove all items from the list
  void Erase();

  // get current item
  T Get();

  // YES if current item is last item
  KhBoolean AtTail();

  // set current item to head of list
  KhBoolean ToHead();

  // move to next item in list
  KhBoolean ToNext();

  // interrogate list
  size_t  GetCount();
  size_t  GetLimit();
  KhBoolean IsCircular();

 protected:
  size_t Count;      // # of items in list
  size_t Work;       // currently-selected element
  T Data[Limit];     // elements in list

  KhBoolean Circular; // is this a circular list?

  // internal utility functions
  void DeepCopy
  (
   const KhSList<T,Limit> & slst
   );
};

// inline member functions

// remove all items from the list
template <class T, size_t Limit>
inline void KhSList<T,Limit>::Erase()
{
  Count = 0;
  Work  = 0;
}

// constructors
template <class T, size_t Limit>
inline KhSList<T,Limit>::KhSList
(
 KhBoolean circ
 )
{
  Count    = 0;
  Work     = 0;
  Circular = circ;
}

// copy constructor
template <class T, size_t Limit>
inline KhSList<T,Limit>::KhSList
(
 const KhSList<T,Limit> & slst
 )
{
  DeepCopy(slst);
}

// destructor
template <class T, size_t Limit>
inline KhSList<T,Limit>::~KhSList()
{
  Erase();
}

// assignment operator (deep copy)
template <class T, size_t Limit>
inline void KhSList<T,Limit>::operator =
(
 const KhSList<T,Limit> & slst
 )
{
  Erase();
  DeepCopy(slst);
}

// YES if current item is last item
template <class T, size_t Limit>
inline KhBoolean KhSList<T,Limit>::AtTail()
{
  if (Work == Count)
	return YES;
  else
	return NO;
}

// set current item to head of list
template <class T, size_t Limit>
inline KhBoolean KhSList<T,Limit>::ToHead()
{
  Work = 0;
  if (Count == 0)
  {
    return NO;
  }
  else
  {
    return YES;
  }
}

// interrogate list
template <class T, size_t Limit>
inline size_t KhSList<T,Limit>::GetCount()
{
  return Count;
}

template <class T, size_t Limit>
inline size_t KhSList<T,Limit>::GetLimit()
{
  return Limit;
}

template <class T, size_t Limit>
inline KhBoolean KhSList<T,Limit>::IsCircular()
{
  return Circular;
}


#endif

/*; end of file */
